<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>LibraryMgr: models/Database/Database.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibraryMgr
   &#160;<span id="projectnumber">0.4</span>
   </div>
   <div id="projectbrief">Library manager desktop app</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_database_8h_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Database.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#ifndef LIBRARYMGR_DATABASE_H</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#define LIBRARYMGR_DATABASE_H</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;algorithm&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;ostream&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00030"></a><span class="lineno"><a class="line" href="class_database.html">   30</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_database.html">Database</a> {</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="comment">// constructors</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="class_database.html#aaafc4cda318124e4d41c994ef9939fa0">   37</a></span>&#160;    <a class="code" href="class_database.html#aaafc4cda318124e4d41c994ef9939fa0">Database</a>() {}</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="class_database.html#a1f1458358b96c2e661d321f3bba963ff">   43</a></span>&#160;    <a class="code" href="class_database.html#a1f1458358b96c2e661d321f3bba963ff">Database</a>(<a class="code" href="class_database.html">Database</a> &amp;d) : items(d.items) {}</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="class_database.html#a4aa986777fd39f9c2cf20ccd0e981e7b">   48</a></span>&#160;    <a class="code" href="class_database.html#a4aa986777fd39f9c2cf20ccd0e981e7b">~Database</a>() {}</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno"><a class="line" href="class_database.html#ab71463e7202e9e13e6db713616d536c3">   55</a></span>&#160;    T <a class="code" href="class_database.html#ab71463e7202e9e13e6db713616d536c3">operator[]</a>(<span class="keywordtype">int</span> i)<span class="keyword"> const </span>{</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <span class="keywordflow">return</span> items[i];</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    }</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="class_database.html#a904f8a7375009e5266c9ca3087506420">   64</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_database.html#a904f8a7375009e5266c9ca3087506420">add</a>(T item, <span class="keywordtype">bool</span> allowDuplicates = <span class="keyword">false</span>) {</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        <span class="keywordflow">if</span> (allowDuplicates) {</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;            items.push_back(item);</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        } <span class="keywordflow">else</span> {  <span class="comment">// no duplicates -&gt; find if there is already the item</span></div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;            <span class="keywordflow">if</span> (!<a class="code" href="class_database.html#a9e868f7b561ee7bec6dad42c632ca16d">isInDatabase</a>(item)) {</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;                items.push_back(item);</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;            }</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        }</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    }</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno"><a class="line" href="class_database.html#a6d8e1621305132ecca4e1b21e918d021">   78</a></span>&#160;    <span class="keywordtype">void</span> <span class="keyword">remove</span>(T item) {</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; items.size(); i++) {</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;            <span class="keywordflow">if</span> (items[i] == item) {</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;                items.erase(items.begin() + i);  <span class="comment">// remove item</span></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;            }</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        }</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    }</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00091"></a><span class="lineno"><a class="line" href="class_database.html#a6e4e2967614f44e36de1e7fb80bb46de">   91</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="class_database.html#a6e4e2967614f44e36de1e7fb80bb46de">replace</a>(T oldItem, T newItem) {</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        <span class="keywordflow">if</span> (<a class="code" href="class_database.html#a9e868f7b561ee7bec6dad42c632ca16d">isInDatabase</a>(oldItem)) {  <span class="comment">// first check if item is in database</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            <span class="keyword">remove</span>(oldItem);  <span class="comment">// first remove old item</span></div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;            <a class="code" href="class_database.html#a904f8a7375009e5266c9ca3087506420">add</a>(newItem);  <span class="comment">// then replace with new</span></div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        }</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    }</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="comment">// getters</span></div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno"><a class="line" href="class_database.html#a9e868f7b561ee7bec6dad42c632ca16d">  105</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_database.html#a9e868f7b561ee7bec6dad42c632ca16d">isInDatabase</a>(T item)<span class="keyword"> const </span>{</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; items.size(); i++) {</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;            <span class="keywordflow">if</span> (items[i] == item) {</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;            }</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        }</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    }</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno"><a class="line" href="class_database.html#ad2d166028b81d82ac3696b1055759792">  119</a></span>&#160;    T <a class="code" href="class_database.html#ad2d166028b81d82ac3696b1055759792">search</a>(T item)<span class="keyword"> const </span>{</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; items.size(); i++) {</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;            <span class="keywordflow">if</span> (items[i] == item) {</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;                <span class="keywordflow">return</span> items[i];</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;            }</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        }</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        <span class="keywordflow">return</span> NULL;</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    }</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;</div><div class="line"><a name="l00133"></a><span class="lineno"><a class="line" href="class_database.html#aeefe0c4942913d067612694ce92b7c90">  133</a></span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="class_database.html#aeefe0c4942913d067612694ce92b7c90">size</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        <span class="keywordflow">return</span> items.size();</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    }</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00141"></a><span class="lineno"><a class="line" href="class_database.html#ab4a4b719e7cb7bdae488f56aab57c2c2">  141</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="class_database.html#ab4a4b719e7cb7bdae488f56aab57c2c2">isEmpty</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        <span class="keywordflow">return</span> items.empty();</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    }</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;</div><div class="line"><a name="l00149"></a><span class="lineno"><a class="line" href="class_database.html#acb198e1ecf6f67b1e1cc3820dc05195f">  149</a></span>&#160;    std::vector&lt;T&gt; <a class="code" href="class_database.html#acb198e1ecf6f67b1e1cc3820dc05195f">getItems</a>()<span class="keyword"> const </span>{</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        <span class="keywordflow">return</span> items;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    }</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;</div><div class="line"><a name="l00159"></a><span class="lineno"><a class="line" href="class_database.html#af4ddfaac7a165a20482cd5e78e437eaf">  159</a></span>&#160;    <span class="keyword">friend</span> std::ostream &amp;operator&lt;&lt;(std::ostream &amp;out, const Database&lt;T&gt; &amp;database) {</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        std::vector&lt;T&gt; itemsList = database.getItems();</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        out &lt;&lt; <span class="stringliteral">&quot;Database&quot;</span> &lt;&lt; std::endl</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;            &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; std::endl;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;        <span class="keywordflow">for</span> (<span class="keyword">typename</span> std::vector&lt;T&gt;::iterator i = itemsList.begin(); i != itemsList.end(); i++) {</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;            out &lt;&lt; <span class="stringliteral">&quot;\t&quot;</span> &lt;&lt; *i &lt;&lt; std::endl;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        }</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;        out &lt;&lt; <span class="stringliteral">&quot;]&quot;</span>;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        <span class="keywordflow">return</span> out;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    }</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    std::vector&lt;T&gt; items;</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;};</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;<span class="preprocessor">#endif // LIBRARYMGR_DATABASE_H</span></div><div class="ttc" id="class_database_html_ad2d166028b81d82ac3696b1055759792"><div class="ttname"><a href="class_database.html#ad2d166028b81d82ac3696b1055759792">Database::search</a></div><div class="ttdeci">T search(T item) const </div><div class="ttdoc">searches in database for given item </div><div class="ttdef"><b>Definition:</b> Database.h:119</div></div>
<div class="ttc" id="class_database_html_aaafc4cda318124e4d41c994ef9939fa0"><div class="ttname"><a href="class_database.html#aaafc4cda318124e4d41c994ef9939fa0">Database::Database</a></div><div class="ttdeci">Database()</div><div class="ttdoc">Database new database from scratch. </div><div class="ttdef"><b>Definition:</b> Database.h:37</div></div>
<div class="ttc" id="class_database_html_a904f8a7375009e5266c9ca3087506420"><div class="ttname"><a href="class_database.html#a904f8a7375009e5266c9ca3087506420">Database::add</a></div><div class="ttdeci">void add(T item, bool allowDuplicates=false)</div><div class="ttdoc">adds new item (if there is no duplicate) </div><div class="ttdef"><b>Definition:</b> Database.h:64</div></div>
<div class="ttc" id="class_database_html_a9e868f7b561ee7bec6dad42c632ca16d"><div class="ttname"><a href="class_database.html#a9e868f7b561ee7bec6dad42c632ca16d">Database::isInDatabase</a></div><div class="ttdeci">bool isInDatabase(T item) const </div><div class="ttdef"><b>Definition:</b> Database.h:105</div></div>
<div class="ttc" id="class_database_html_acb198e1ecf6f67b1e1cc3820dc05195f"><div class="ttname"><a href="class_database.html#acb198e1ecf6f67b1e1cc3820dc05195f">Database::getItems</a></div><div class="ttdeci">std::vector&lt; T &gt; getItems() const </div><div class="ttdoc">getItems gets items in database </div><div class="ttdef"><b>Definition:</b> Database.h:149</div></div>
<div class="ttc" id="class_database_html_aeefe0c4942913d067612694ce92b7c90"><div class="ttname"><a href="class_database.html#aeefe0c4942913d067612694ce92b7c90">Database::size</a></div><div class="ttdeci">unsigned long size() const </div><div class="ttdoc">gets size of database </div><div class="ttdef"><b>Definition:</b> Database.h:133</div></div>
<div class="ttc" id="class_database_html_ab4a4b719e7cb7bdae488f56aab57c2c2"><div class="ttname"><a href="class_database.html#ab4a4b719e7cb7bdae488f56aab57c2c2">Database::isEmpty</a></div><div class="ttdeci">bool isEmpty() const </div><div class="ttdoc">checks if database is empty </div><div class="ttdef"><b>Definition:</b> Database.h:141</div></div>
<div class="ttc" id="class_database_html_a6e4e2967614f44e36de1e7fb80bb46de"><div class="ttname"><a href="class_database.html#a6e4e2967614f44e36de1e7fb80bb46de">Database::replace</a></div><div class="ttdeci">void replace(T oldItem, T newItem)</div><div class="ttdoc">replaces item with new item if old item is in database </div><div class="ttdef"><b>Definition:</b> Database.h:91</div></div>
<div class="ttc" id="class_database_html_a1f1458358b96c2e661d321f3bba963ff"><div class="ttname"><a href="class_database.html#a1f1458358b96c2e661d321f3bba963ff">Database::Database</a></div><div class="ttdeci">Database(Database &amp;d)</div><div class="ttdoc">Database deep copy of database. </div><div class="ttdef"><b>Definition:</b> Database.h:43</div></div>
<div class="ttc" id="class_database_html"><div class="ttname"><a href="class_database.html">Database</a></div><div class="ttdoc">Abstract collection of object. </div><div class="ttdef"><b>Definition:</b> Database.h:30</div></div>
<div class="ttc" id="class_database_html_a4aa986777fd39f9c2cf20ccd0e981e7b"><div class="ttname"><a href="class_database.html#a4aa986777fd39f9c2cf20ccd0e981e7b">Database::~Database</a></div><div class="ttdeci">~Database()</div><div class="ttdoc">~Database delete database </div><div class="ttdef"><b>Definition:</b> Database.h:48</div></div>
<div class="ttc" id="class_database_html_ab71463e7202e9e13e6db713616d536c3"><div class="ttname"><a href="class_database.html#ab71463e7202e9e13e6db713616d536c3">Database::operator[]</a></div><div class="ttdeci">T operator[](int i) const </div><div class="ttdoc">operator [] reference to item </div><div class="ttdef"><b>Definition:</b> Database.h:55</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_1ae4179d5e953611aae20c997279e02c.html">models</a></li><li class="navelem"><a class="el" href="dir_700c5bf6ef75ee8e3de358ef7f4ea2a6.html">Database</a></li><li class="navelem"><b>Database.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
